import {Component, OnInit} from '@angular/core';
import {fadeIn} from '../../animation/fade-in';
import {ApiService} from '../../service/api';
import {NzMessageService} from 'ng-zorro-antd';
import {Router} from '@angular/router';

@Component({
  selector: 'app-gateway',
  templateUrl: './gateway.component.html',
  styles: [`
    :host ::ng-deep .anticon-filter {
      left: 73px;
    }
    .btnPart {
      padding: 10px;
    }
  `],
  animations: [fadeIn]
})
export class GatewayComponent implements OnInit {

  data = [];
  query = {
    gatewayName: '',
    gatewaySN: ''
  };
  isLoading = false;
  isAllCheck = false;
  isIndeterminate = false;
  checkArray = [];
  page = 1;
  rows = 10;
  total = 125;
  listOfBind = [{text: '全部', value: 1}, {text: '已绑定', value: 2}, {text: '未绑定', value: 3}];

  constructor(private api: ApiService, private message: NzMessageService, private router: Router) {
  }

  ngOnInit() {
    this.init();
  }

  init() {
    this.getData();
  }

  next = (data) => {
    if (data && data.rows && data.rows.constructor === Array) {
      this.data = data.rows;
      this.total = data.total;
      this.initCheckArray(data.rows.length, false);
    } else if (data.code === 1) {
      this.message.success(data && data.message ? data.message : '操作成功');
    } else if (data.code === 0) {
      this.message.error(data && data.message ? data.message : '操作失败');
    } else {
      this.message.error(data && data.message ? data.message : '获取数据失败');
    }
    this.isLoading = false;
  };

  getData() {
    this.isLoading = true;
    this.api.loginlog.getAll(this.page, this.rows, ['', this.next]);
  }

  initCheckArray(n, b) {
    const obj = [];
    while (n > 0) {
      obj.push(b);
      n--;
    }
    this.checkArray = obj;
  }

  onSearch() {
  }

  onGetAll() {
  }

  checkAll(e) {
    this.isIndeterminate = false;
    this.initCheckArray(this.checkArray.length, e);
  }

  oneCheck(i) {
    const x = this.checkArray.filter(k => k).length;
    if (x === this.checkArray.length) {
      this.isIndeterminate = false;
      this.isAllCheck = true;
    } else if (x === 0) {
      this.isIndeterminate = false;
      this.isAllCheck = false;
    } else {
      this.isIndeterminate = true;
      this.isAllCheck = false;
    }
  }

  filter(a, b) {
    console.log(a, b);
  }

  delete() {}

  divide() {}

  bind() {}

  unbind() {}

  update() {}

  toSee(e) {
    this.router.navigate(['/app/deviceCenter/gatewayMgr/gatewaySee']);
  }
}
